!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! modules.f90	Declaration of global variables.
!
! twnh 13Aug01 & pdw 5Jun02
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

MODULE precision

! working precision, wp, and saving precision, sp; KIND(1.0)=single, KIND(1.0D0)=double

INTEGER, PARAMETER			:: wp = KIND(1.0D0) 
INTEGER, PARAMETER			:: sp = KIND(1.0)

END MODULE precision

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

MODULE dyn_vars

! dynamical state arrays

USE precision

REAL (KIND=wp), ALLOCATABLE, SAVE	:: q(:,:,:,:), psi(:,:,:,:), q_tend(:,:,:), & 
						q_relax(:,:,:), psi_relax(:,:,:), random(:,:), top_forc_coeff(:,:,:)

END MODULE dyn_vars

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

MODULE solver_vars

! permanent solver arrays

USE precision

REAL (KIND=wp), ALLOCATABLE, SAVE	:: fft_coeffs(:)
COMPLEX (KIND=wp), ALLOCATABLE, SAVE	:: a_bt_fac(:,:,:), a_bc_fac(:,:,:)
INTEGER, ALLOCATABLE, SAVE		:: pivot_bt(:,:), pivot_bc(:,:)

END MODULE solver_vars

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

MODULE phys_params

! physical parameters

USE precision

REAL (KIND=wp), SAVE			:: a, H, omega, g, pi, f, g_primed, itcc, lambda_bt, lambda_bc, &
						relax_rate, new_hyper, forcing_coeff, lid_delta_omega, &
						initial_amplitude, noise_amp, d_dt_noise_amp, s_top, s_bot
REAL (KIND=wp), ALLOCATABLE, SAVE	:: spindown_rate(:), chi(:), delta_omega(:)
INTEGER, SAVE				:: relax_type, internal_ekman

END MODULE phys_params

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

MODULE grid_params

! grid parameters

USE precision

INTEGER, SAVE				:: N_rad, N_azim, N_layer, step, start_step, end_step, &
						prev_step, this_step, next_step, &
						dump_period, pickup_dump_period, debug, reset_period
REAL (KIND=wp), SAVE 			:: delta_r, delta_theta, delta_t, Robert_filter_parameter, area
REAL (KIND=wp), ALLOCATABLE, SAVE	:: rad_dist(:), area_element(:,:)

END MODULE grid_params

